Attribute VB_Name = "Module1"
' Clipview sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/clipview.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.

Option Explicit

Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function ChangeClipboardChain Lib "user32" (ByVal hwnd As Long, ByVal hWndNext As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SetClipboardViewer Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Const WM_DESTROY = &H2
Public Const WM_DRAWCLIPBOARD = &H308
Public Const WM_CHANGECBCHAIN = &H30D
Public Const GWL_WNDPROC = (-4)

Public lOrig As Long, lhWndChain As Long

Public Function AppWndProc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If lOrig = 0 Then
        lOrig = Val(GetSetting("ClipView", "WndProc", CStr(hwnd)))
        GoTo DestroyIt
    End If
        
    Select Case Msg
        Case WM_DRAWCLIPBOARD
            If Clipboard.GetFormat(vbCFText) Then Form1.Text1.Text = Clipboard.GetText
            If Clipboard.GetFormat(vbCFBitmap) Then Form1.Picture1.Picture = Clipboard.GetData(vbCFBitmap)
            SendMessage lhWndChain, Msg, wParam, ByVal lParam
        Case WM_DESTROY
DestroyIt:
            SetWindowLong hwnd, GWL_WNDPROC, lOrig
            AppWndProc = CallWindowProc(lOrig, hwnd, Msg, wParam, lParam)
            DeleteSetting "ClipView", "WndProc", CStr(hwnd)
            lOrig = 0
            Exit Function
    End Select
    AppWndProc = CallWindowProc(lOrig, hwnd, Msg, wParam, lParam)
End Function
